unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, MemNT, ExtCtrls, ShellApi;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MemNT1: TMemNT;
    Panel2: TPanel;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    HomePage1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    Bevel1: TBevel;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure HomePage1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses Unit2;

{$R *.DFM}


function HexToDec(aValue: String): DWORD;
var
  l: DWORD;
  b: Byte;
begin
  Result := 0;
  if Length(aValue) <> 0 then
   begin
     l := 1;
     b := Length(aValue) + 1;
     repeat
      dec(b);
      if aValue[b] <= '9' then Result := Result + (Byte(aValue[b]) - 48) * l
      else Result := Result + (Byte(aValue[b]) - 55) * l;
      l := l * 16;
     until b = 1;
   end;
end;



procedure TMainForm.Button2Click(Sender: TObject);
var
  i, Length, Address, ReturnValue: integer;
  Buf: array [0..$F000] of char;
  Str: string;
begin
   Memo1.Clear;

   Address := hextodec(Edit1.text);
   Length  := hextodec(Edit2.text);


   ReturnValue := MemNT1.ReadMemory(Address, Length, buf);
   if ReturnValue = 0 then
   begin
     for i := 0 to Length - 1 do
     begin
       if ((i mod 16)=0) and (i>0) then Str := Str + #13#10;
       Str := Str + inttohex(byte(buf[i]),2) + ' ';
     end;
     Memo1.Text := Str;
   end;

   case ReturnValue of
     -5:showmessage('Memory Address out of range !');
     -1:showmessage('Memory block out of range !');
     -2:showmessage('Can not open section !');
     -3:showmessage('Can not map memory !');
     -4:showmessage('Can not unmap memory !');
   end;

end;


procedure TMainForm.FormShow(Sender: TObject);
begin
  Application.Title:=MainForm.Caption;
  MainForm.Caption:=MainForm.Caption+' (Total Physical memory : '+inttohex(memnt1.TotalPhysMemory,8)+')';
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.HomePage1Click(Sender: TObject);
begin
  ShellExecute($80, 'open', PChar('http://zwsoft.500.to'), '', '', SW_SHOWDEFAULT);
end;

end.
